#include <bits/stdc++.h>
using namespace std;
int nbb(int x){
    if(x==0) return -1;
    return (int)log2(x);
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin>>n>>q;
    vector<int> a(n);
    vector<vector<int>> pref(31,vector<int>(n+1,0));
    for(int i=0; i<n; i++){
        cin>>a[i];
        int b=nbb(a[i]);
        for(int j=0; j<31; j++){
            pref[j][i+1]=pref[j][i];
        }
        if(b!=-1) pref[b][i+1]++;
    }
    while(q--){
        int l,r;
        cin>>l>>r;
        l--;
        r--;
        int res=0;
        for(int b=0; b<31; b++){
            res=max(res,pref[b][r+1]-pref[b][l]);
        }
        cout<<res<<'\n';
    }
}